(ns org.aurellem.genesis_demonstration
  (:use clojure.java.shell)
  (:use org.aurellem.worm-learn)
  (:use org.aurellem.self-organizing-touch)
  (:use cortex.test)
  (:use cortex.import)
  (:use cortex.util))

(mega-import-jme3)
(def play (comp dorun (partial sh "mplayer" "-fs")))


(comment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;     CORTEX       ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;; show some bodies
(.start (cortex.test.body/test-hand-3))
(play "/home/r/proj/cortex/video/full-hand.ogg")


;; hearing
;; interactive hearing
(run-test #'cortex.test.hearing/test-worm-hearing)
;; multiple listeners
(run-test #'cortex.test.hearing/test-java-hearing)
(play "/home/r/proj/cortex/video/java-hearing-test.ogg")

;; touch
(run-test #'cortex.test.touch/test-basic-touch)
(play "/home/r/proj/cortex/video/basic-touch.ogg")

;; proprioception
(run-test #'cortex.test.proprioception/test-proprioception)

;; movement
(run-test #'cortex.test.movement/test-worm-movement)

;; instrumented hand
(play "/home/r/proj/cortex/video/hand-fixed.mkv")


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;      EMPATH       ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;; init system with a basic training script
(init)
;; demonstrate basic empathy; view phi-space
(empathy-experiment-1 false)
;; init system with an interactive training session
(init-interactive)
;; empathy is much better with more training
(empathy-experiment-2)

;;;;; Learning touch

;; small worm segment that learns its topology 
(learn-and-view-touch-regions)



)